#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <stdint.h>
#include <string.h>
#include <error.h>
#include <sys/fsuid.h>
#include <stdlib.h>

#include "utils.h"
#include "extacl.h"

int main(int argc, char **argv) {
    int uid = atoi(argv[1]);
    int f;
    char buf[8192];
    char buf2[sizeof(buf)];
    struct extacl extacl[] = {
        {
            .type = EXTACL_USER_READ,
            .uid_gid = uid,
            .range_start = 1024,
            .range_len = sizeof(buf) + 1,
        },
    };

    if (argc < 2)
        error(1, 0, "argc");

    f = open("testfile", O_CREAT | O_RDWR, 0600);
    if (f < 0)
        error(1, errno, "open");
    memset(buf, 42, sizeof(buf));
    if (write(f, buf, sizeof(buf)) != sizeof(buf))
        error(1, errno, "write");
    if (fchown(f, uid, -1) == -1)
        error(1, errno, "fchown");
    close(f);

    if (extacl_set_file("testfile", extacl, ARRAY_SIZE(extacl)) != ARRAY_SIZE(extacl))
        error(1, errno, "extacl_set_file");

    if (setfsuid(uid) == -1)
        error(1, errno, "setfsuid");

    f = open("testfile", O_RDONLY);
    if (f < 0)
        error(1, errno, "open read");
    if (read(f, buf2, sizeof(buf2)) != sizeof(buf2))
        error(1, errno, "read as owner");

    if (memcmp(buf, buf2, sizeof(buf)))
        error(1, 0, "memcmp");
    close(f);

    f = open("testfile", O_WRONLY);
    if (f < 0)
        error(1, errno, "open write");
    memset(buf, 22, sizeof(buf));
    if (write(f, buf, sizeof(buf)) != sizeof(buf))
        error(1, errno, "write as owner");

    close(f);
    return 0;
}
