#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <stdint.h>
#include <string.h>
#include <error.h>
#include <sys/fsuid.h>
#include <stdlib.h>

#include "utils.h"
#include "extacl.h"

int main(int argc, char **argv) {
    int uid = atoi(argv[1]);
    int gid = atoi(argv[2]);
    int f;
    char buf[8192];
    char buf2[sizeof(buf)];

    if (argc < 2)
        error(1, 0, "argc");

    f = open("testfile", O_CREAT | O_RDWR, 0640);
    if (f < 0)
        error(1, errno, "open");
    memset(buf, 42, sizeof(buf));
    if (write(f, buf, sizeof(buf)) != sizeof(buf))
        error(1, errno, "write");
    fchown(f, -1, gid);
    close(f);

    if (setfsuid(uid) == -1)
        error(1, errno, "setfsuid");

    f = open("testfile", O_RDONLY);
    if (f >= 0 || errno != EACCES)
        error(1, errno, "open read succeeded or errno != EACCES");
    close(f);

    f = open("testfile", O_WRONLY);
    if (f >= 0 || errno != EACCES)
        error(1, errno, "open write succeeded or errno != EACCES");
    close(f);

    if (setfsuid(uid+1) == -1)
        error(1, errno, "setfsuid 2");
    if (setfsgid(gid) == -1)
        error(1, errno, "setfsgid");

    f = open("testfile", O_RDONLY);
    if (f < 0)
        error(1, errno, "open read");
    if (read(f, buf2, sizeof(buf2)) != sizeof(buf2))
        error(1, errno, "read");

    if (memcmp(buf, buf2, sizeof(buf)))
        error(1, 0, "memcmp");
    close(f);

    f = open("testfile", O_WRONLY);
    if (f >= 0)
        error(0, errno, "open write succeeded");
    if (f >= 0 && write(f, buf2, sizeof(buf2)) > 0)
        error(1, errno, "write succeeded");

    close(f);

    return 0;
}
